<?php
/*
Plugin Name: Multisite Full Backup
Description: מבצע גיבוי מלא לאתר וורדפרס מולטיסייט, כולל כל הקבצים, המדיה וה־Database, שחזור מלא, שחזור לאתר חדש עם DB חדש, wp-config, עדכון URL וחיבור לרשת, ונשמר תחת public_html
Version: 2.0
Author: פיני
*/

$backup_dir = dirname(ABSPATH) . '/wp_full_backups/';
if (!is_dir($backup_dir)) mkdir($backup_dir, 0755, true);

$log_file = $backup_dir . 'backup_log.txt';
$sql_file = $backup_dir . 'database_dump.sql';

function mfb_log($msg) {
    global $log_file;
    file_put_contents($log_file, '[' . date('Y-m-d H:i:s') . '] ' . $msg . PHP_EOL, FILE_APPEND);
}

function mfb_restore_backup($file, $to_new_site = false, $new_db_name = '', $new_db_user = '', $new_db_pass = '', $new_site_url = '') {
    // שחזור כפי שהיה (לא מוצג כאן לקיצור)
}

function mfb_render_backup_page() {
    global $backup_dir;

    echo '<div class="wrap" style="direction: rtl; text-align: right;">';
    echo '<h1>גיבוי ושחזור מלא לרשת</h1>';
    echo '<form id="mfb-backup-form" method="post">';
    echo '<input type="submit" name="mfb_backup" class="button button-primary" value="📦 בצע גיבוי מלא עכשיו">';
    echo '<span id="mfb-spinner" style="display:none;margin-right:10px;"><span class="spinner is-active" style="float:none;"></span> <strong>מבצע גיבוי... אנא המתן (כ-30 שניות)</strong></span>';
    echo '</form>';

    echo '<script>
        document.getElementById("mfb-backup-form").addEventListener("submit", function () {
            document.getElementById("mfb-spinner").style.display = "inline-block";
        });
    </script>';

    if (isset($_POST['mfb_backup'])) {
        echo '<pre style="direction: rtl; text-align: right;">⏳ מתחיל גיבוי מלא... אנא המתן...
';
        $timestamp = date('Y-m-d_H-i-s');
        $zip_file = $backup_dir . "backup_full_$timestamp.zip";

        $db_user = DB_USER;
        $db_pass = DB_PASSWORD;
        $db_name = DB_NAME;
        $db_host = DB_HOST;

        echo "📦 שלב 1/4 - יוצרים קובץ SQL (כ-10 שניות)...\n";
        $cmd_db = sprintf('mysqldump -u%s -p%s -h%s %s > %s', escapeshellarg($db_user), escapeshellarg($db_pass), escapeshellarg($db_host), escapeshellarg($db_name), escapeshellarg($GLOBALS['sql_file']));
        exec($cmd_db);

        echo "📁 שלב 2/4 - אורזים את הקבצים (כ-15 שניות)...\n";
        $cmd_zip = sprintf('cd %s && zip -r %s * -x wp_full_backups/*', escapeshellarg(ABSPATH), escapeshellarg($zip_file));
        exec($cmd_zip);

        echo "🧹 שלב 3/4 - מנקים SQL זמני...\n";
        unlink($GLOBALS['sql_file']);

        echo "✅ שלב 4/4 - הגיבוי נשמר ב־$zip_file\n";
        echo '</pre>';
    }

    echo '<hr><h2>📜 גיבויים קיימים:</h2><ul style="font-family:monospace; direction: rtl; text-align: right;">';
    $files = glob($backup_dir . 'backup_full_*.zip');
    if ($files) {
        usort($files, function($a, $b) { return filemtime($b) - filemtime($a); });
        foreach ($files as $file) {
            $name = basename($file);
            echo "<li>$name
                <form method='post' style='display:inline;' onsubmit=\"return confirm('שחזר לאתר הקיים?');\">
                    <input type='hidden' name='mfb_restore_file' value='$name'>
                    <input type='submit' class='button' value='♻️ שחזר אתר נוכחי'>
                </form>
                <form method='post' style='display:inline;margin-right:10px;' onsubmit=\"return confirm('שחזר לאתר חדש?');\">
                    <input type='hidden' name='mfb_restore_new' value='$name'>
                    <input type='text' name='new_db' placeholder='DB name' required>
                    <input type='text' name='new_user' placeholder='DB user' required>
                    <input type='password' name='new_pass' placeholder='DB password' required>
                    <input type='text' name='new_url' placeholder='https://newsite.com' required>
                    <input type='submit' class='button' value='🆕 שחזר אתר חדש'>
                </form></li>";
        }
    } else {
        echo '<li>אין עדיין גיבויים.</li>';
    }
    echo '</ul>';

    if (isset($_POST['mfb_restore_file'])) {
        $file = sanitize_text_field($_POST['mfb_restore_file']);
        echo '<pre style="direction: rtl; text-align: right;">♻️ שחזור לאתר קיים...
';
        mfb_restore_backup($file);
        echo "✅ הסתיים השחזור.
</pre>";
    }

    if (isset($_POST['mfb_restore_new'])) {
        $file = sanitize_text_field($_POST['mfb_restore_new']);
        $new_db = sanitize_text_field($_POST['new_db']);
        $new_user = sanitize_text_field($_POST['new_user']);
        $new_pass = sanitize_text_field($_POST['new_pass']);
        $new_url = esc_url_raw($_POST['new_url']);
        echo '<pre style="direction: rtl; text-align: right;">🆕 שחזור לאתר חדש...
';
        mfb_restore_backup($file, true, $new_db, $new_user, $new_pass, $new_url);
        echo "✅ הסתיים שחזור לאתר חדש.
</pre>";
    }
    echo '</div>';
}

add_action('network_admin_menu', function () {
    add_menu_page('Multisite Backup', '🗄️ גיבוי מלא', 'manage_network', 'multisite-full-backup', 'mfb_render_backup_page', 'dashicons-backup', 99);
});
